
KWParser = {
    /**
     * Set it to override the document.referrer string. Used for debugging
     * only.
     */
    debug_referrer: ''
};

KWParser.search_engines = [
    ['google',		'google\\.', 'q'],                             // Google
    ['yahoo',		'search\\.yahoo\\.', 'p'],                     // Yahoo
    ['msn',			'search\\.msn\\.', 'q'],                       // MSN
    ['live',		'search\\.live\\.', 'query'],                  // MSN Live
    ['aol',			'search\\.aol\\.', 'userQuery'],               // AOL
    ['ask',			'ask\\.com', 'q'],                             // Ask.com
    ['altavista',	'altavista\\.', 'q'],                          // AltaVista
    ['feedster',	'feedster\\.', 'q'],                           // Feedster
    ['lycos',		'search\\.lycos\\.', 'q'],                     // Lycos
    ['alltheweb',	'alltheweb\\.', 'q'],                          // AllTheWeb
    ['technorati',	'technorati\\.com/search/([^\\?/]+)', 1],      // Technorati
    ['dogpile',		'dogpile\\.com/info\\.dogpl/search/web/([^\\?/]+)', 1, true], // DogPile
	['lemos',		'lemos\\.','q']								// LemosNet
];


/**
 * Decode the referrer string and return a list of search keywords.
 */
KWParser.decodeReferrer = function(referrer) {
    var query = null;
    var regex = new RegExp('');

    for (var i = 0; i < KWParser.search_engines.length; i ++) {
        var se = KWParser.search_engines[i];
        regex.compile('^http://(www\\.)?' + se[1], 'i');
        var match = referrer.match(regex);
        if (match) {
            var result;
            if (isNaN(se[2])) {
                result = KWParser.decodeReferrerQS(referrer, se[2]);
            } else {
                result = match[se[2] + 1];
            }
            if (result) {
                result = decodeURIComponent(result);
                // XXX: DogPile's URI requires decoding twice.
                if (se.length > 3 && se[3])
                    result = decodeURIComponent(result);
                result = result.replace(/\'|"/g, '');
                result = result.split(/[\s,\+\.]+/);
                return [se[0],result];
            }
            break;
        }
    }
    return null;
};

KWParser.decodeReferrerQS = function(referrer, match) {
    var idx = referrer.indexOf('?');
    var idx2;
    if (idx >= 0) {
        var qs = new String(referrer.substring(idx + 1));
        idx  = 0;
        idx2 = 0;
        while ((idx >= 0) && ((idx2 = qs.indexOf('=', idx)) >= 0)) {
            var key, val;
            key = qs.substring(idx, idx2);
            idx = qs.indexOf('&', idx2) + 1;
            if (key == match) {
                if (idx <= 0) {
                    return qs.substring(idx2+1);
                } else {
                    return qs.substring(idx2+1, idx - 1);
                }
            }
        }
    }
    return null;
};

KWParser.parse = function() {
    // If 'debug_referrer' then we will use that as our referrer string
    // instead.
    var q = KWParser.debug_referrer ? KWParser.debug_referrer : document.referrer;
    var e = null;
    q = KWParser.decodeReferrer(q);
    return q;
};

var readers_src = '' + 
'' + 
'<!-- http://blogblogs.com.br/embed/readers version 2.0 -->' + 
'' + 
'<style type="text/css">' + 
'#bbw_readers, #bbw_readers *, #bbw_readers div, #bbw_readers a, #bbw_readers a:hover { ' + 
'	margin:0px; padding:0px; border:0px;' + 
'	font-family:Verdana, Arial, Helvetica, sans-serif;' + 
'	font-size: 12px; font-weight: normal;' + 
'	text-align: left; color: #FFF; line-height:1em; }' + 
'#bbw_readers { background-color:#693;  width:169px; color:#FFF; padding:2px; text-align:center;}' + 
'#bbw_readers * a, #bbw_readers * a:hover { text-decoration: none; border:0; font-weight: normal; color: #fff; }' + 
'#bbw_readers .bbw_title { background:#A4C840; text-align: center; padding:0; font-weight:bold; height:30px; }' + 
'#bbw_readers .bbw_icons {  background-color:#5EC624; padding:0px; font-size:1px; height:26px;' + 
'	margin-top:2px; margin-bottom: 2px; text-align:center;' + 
'	background-image:url(http://assets4.blogblogs.com.br/public/bb/embed/readers/menubg.jpg); }' + 
'#bbw_readers .bbw_rank { background-color:#5EC624; padding:2px;' + 
'	margin-bottom:2px; text-align:center;' + 
'	background-image:url(http://assets4.blogblogs.com.br/public/bb/embed/readers/menubg.jpg); }' + 
'#bbw_readers .bbw_rank strong { font-weight: bold; }' + 
'#bbw_readers .bbw_entry { padding:2px 0 1px 2px; }' + 
'#bbw_readers .bbw_entry:hover { padding:2px 0 1px 2px; background-color:#9C3; }' + 
'#bbw_readers .bbw_entry2 { padding:2px 0 1px 2px; background-color:#5EC624;' + 
'	background-image:url(http://assets4.blogblogs.com.br/public/bb/embed/readers/menubg.jpg); }' + 
'#bbw_readers .bbw_entry2:hover { padding:2px 0 1px 2px; background-color:#9C3; background-image:url(); }' + 
'#bbw_readers .bbw_entry a, #bbw_readers .bbw_entry2 a { text-decoration: none; }' + 
'#bbw_readers .bbw_entry a:hover, #bbw_readers .bbw_entry2 a:hover { text-decoration: none; color:#360; }' + 
'#bbw_readers .bbw_avatar { height:24px; width:24px; border:0px; }' + 
'#bbw_readers .bbw_avatar { border:4px solid #693; }' + 
'#bbw_readers .bbw_avatar:hover { border:4px solid #9C3; }' + 
'#bbw_readers .bbw_subtitle { text-align: center; font-size: 10px; background-color:#360; padding:2px; }' + 
'#bbw_readers .bbw_control { text-align: center; font-size: 10px; background-color:#030; padding:2px; margin-top:2px; }' + 
'#bbw_readers .bbw_footer { text-align: center; font-size: 10px; background-color:#360; padding:1px;}' + 
'#bbw_readers .bbw_control a, #bbw_readers .bbw_footer a, #bbw_readers .bbw_rank a { font-size: 10px; font-weight: bold;}' + 
'#bbw_readers .bbw_control a:hover, #bbw_readers .bbw_footer a:hover, #bbw_readers .bbw_rank a:hover { font-size: 10px; color:#9C3; }' + 
'</style>' + 
'' + 
'<style type="text/css">' + 
'	#bbw_readers .ut, #bbw_readers .ut * { border:0px; margin:0px; padding:0px; font-size:1px; display:none; }' + 
'</style>' + 
'' + 
'<div id="bbw_readers">' + 
'	<div class=\'bbw_title\'>' + 
'		<a href=\'http://blogblogs.com.br\'><img src=\'http://assets5.blogblogs.com.br/public/bb/embed/readers/widget_head.jpg\'></a>	</div>' + 
'	<div class=\'bbw_icons\'>' + 
'				<a href="http://blogblogs.com.br/people/view/50763" title="Perfil do atribeiro">' + 
'			<img src="http://assets5.blogblogs.com.br/public/bb/embed/readers/user.jpg">' + 
'		</a>' + 
'				<a href="http://blogblogs.com.br/blogs/view/167759" title="Ensino de Química">' + 
'			<img src="http://assets2.blogblogs.com.br/public/bb/embed/readers/blog.jpg">' + 
'		</a>			' + 
'		<a href="http://blogblogs.com.br/my/gadgets/fave?url=http://ensquimica.blogspot.com/" title="Adicionar aos meus favoritos no BlogBlogs">' + 
'			<img src="http://assets1.blogblogs.com.br/public/bb/embed/readers/fave.jpg">' + 
'		</a>			' + 
'		<a href="http://blogblogs.com.br/blogs/fans/167759" title="Ver todos os fãs">' + 
'			<img src="http://assets5.blogblogs.com.br/public/bb/embed/readers/fans.jpg">' + 
'		</a>			' + 
'		<a href="http://feeds.feedburner.com/EnsinoDeQumica" title="Assinar o feed deste blog">' + 
'			<img src="http://assets3.blogblogs.com.br/public/bb/embed/readers/feed.jpg">' + 
'		</a>			' + 
'	</div>' + 
'		<div class=\'bbw_rank\'>' + 
'		<a href="http://blogblogs.com.br/blogs/links/167759" title="28 links de 20 sites">' + 
'		Rank:' + 
'		<strong>2888</strong>' + 
'		</a>' + 
'	</div>' + 
'		<div class=\'bbw_subtitle\'>' + 
'		<a href="http://blogblogs.com.br/blogs/readers/167759" title="Ver todos...">Últimas Visitas</a>' + 
'	</div>' + 
'	<!-- visibility_control -->' + 
'	<a href="http://blogblogs.com.br/user/signup" title="Faça parte desta comunidade, venha para o BlogBlogs"><img src="http://assets1.blogblogs.com.br/public/bb/avatars/no_user_24.gif" class="bbw_avatar" alt="Você"></a><a href=\'http://blogblogs.com.br/people/view/87884\' title=\'muzin\'><img src=\'http://assets1.blogblogs.com.br/public/bb/avatars/0/87/avatar_87884_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/32455\' title=\'jadc01\'><img src=\'http://assets4.blogblogs.com.br/public/bb/avatars/0/32/avatar_32455_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/74234\' title=\'rededoblog\'><img src=\'http://assets5.blogblogs.com.br/public/bb/avatars/0/74/avatar_74234_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/9755\' title=\'pharis\'><img src=\'http://assets2.blogblogs.com.br/public/bb/avatars/0/9/avatar_9755_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/56649\' title=\'bethccruz\'><img src=\'http://assets5.blogblogs.com.br/public/bb/avatars/0/56/avatar_56649_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/72270\' title=\'rubiorc\'><img src=\'http://assets5.blogblogs.com.br/public/bb/avatars/0/72/avatar_72270_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/77662\' title=\'orivalmedeiros\'><img src=\'http://assets2.blogblogs.com.br/public/bb/avatars/0/77/avatar_77662_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/87514\' title=\'celorod\'><img src=\'http://assets3.blogblogs.com.br/public/bb/avatars/0/87/avatar_87514_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/9615\' title=\'mielle\'><img src=\'http://assets1.blogblogs.com.br/public/bb/avatars/0/9/avatar_9615_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/61216\' title=\'tigustavo\'><img src=\'http://assets4.blogblogs.com.br/public/bb/avatars/0/61/avatar_61216_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/24803\' title=\'caudo42\'><img src=\'http://assets5.blogblogs.com.br/public/bb/avatars/0/24/avatar_24803_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/59433\' title=\'liverig\'><img src=\'http://assets5.blogblogs.com.br/public/bb/avatars/0/59/avatar_59433_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/75466\' title=\'vanks\'><img src=\'http://assets1.blogblogs.com.br/public/bb/avatars/0/75/avatar_75466_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/84210\' title=\'Foxyy\'><img src=\'http://assets1.blogblogs.com.br/public/bb/avatars/0/84/avatar_84210_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/85426\' title=\'bruno_cortezao\'><img src=\'http://assets3.blogblogs.com.br/public/bb/avatars/0/85/avatar_85426_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/62079\' title=\'SemTosquices\'><img src=\'http://assets4.blogblogs.com.br/public/bb/avatars/0/62/avatar_62079_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/82267\' title=\'MaNiNhOeXpReSs\'><img src=\'http://assets5.blogblogs.com.br/public/bb/avatars/0/82/avatar_82267_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/84402\' title=\'Charlenebarry\'><img src=\'http://assets4.blogblogs.com.br/public/bb/avatars/no_avatar_24.gif\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/50590\' title=\'Roddolfo\'><img src=\'http://assets5.blogblogs.com.br/public/bb/avatars/0/50/avatar_50590_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/83994\' title=\'Ronaldk1\'><img src=\'http://assets4.blogblogs.com.br/public/bb/avatars/no_avatar_24.gif\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/64926\' title=\'interativeweb\'><img src=\'http://assets1.blogblogs.com.br/public/bb/avatars/0/64/avatar_64926_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/78205\' title=\'sonia.lotus\'><img src=\'http://assets3.blogblogs.com.br/public/bb/avatars/0/78/avatar_78205_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/48968\' title=\'fshark\'><img src=\'http://assets2.blogblogs.com.br/public/bb/avatars/0/48/avatar_48968_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/13618\' title=\'josecunha\'><img src=\'http://assets1.blogblogs.com.br/public/bb/avatars/0/13/avatar_13618_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/29865\' title=\'fansdatania\'><img src=\'http://assets4.blogblogs.com.br/public/bb/avatars/0/29/avatar_29865_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/12012\' title=\'HQNews\'><img src=\'http://assets1.blogblogs.com.br/public/bb/avatars/0/12/avatar_12012_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/78101\' title=\'Mox52\'><img src=\'http://assets4.blogblogs.com.br/public/bb/avatars/0/78/avatar_78101_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/45070\' title=\'franklinmoraismoura\'><img src=\'http://assets4.blogblogs.com.br/public/bb/avatars/0/45/avatar_45070_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a><a href=\'http://blogblogs.com.br/people/view/18723\' title=\'ByOscar\'><img src=\'http://assets2.blogblogs.com.br/public/bb/avatars/0/18/avatar_18723_24.jpg\' width=\'24\' height=\'24\' alt=\'?\' class=\'bbw_avatar\'></a>		' + 
'		<div class=\'bbw_footer\'>' + 
'		Por <a href=\'http://blogblogs.com.br\'>BlogBlogs.Com.Br</a><img src=\'http://www.google-analytics.com/__utm.gif?utmwv=1&utmn=5962346553&utmcs=-&utmsr=-&utmsc=-&utmul=-&utmje=0&utmfl=-&utmcr=1&utmdt=Widget > Readers  > Blog: 167759&utmhn=embed.blogblogs.com.br&utmr=BBWREFTK_READERS&utmp=/embed/readers/167759/ensquimica.blogspot.com/2008/01/reao-qumica-e-energia.html&utmac=UA-351784-4&utmcc=__utma%3D88759891.1966950261.1218384217.1218384217.1218384217.2%3B%2B__utmb%3D88759891%3B%2B__utmc%3D88759891%3B%2B__utmz%3D88759891.1218384217.2.2.utmccn%3DBBWCCNTK_READERS%3B%2B__utmv%3D88759891.%3B%2B\' alt=\'\' class=\'ut\'>' + 
'	</div>' + 
'</div>' + 
'' + 
'<!-- End BlogBlogs Readers Widget -->';
var doc = document;
var ref; if (document.referrer == "") { ref = "-" } else { ref = document.referrer; };
var exp = new RegExp("BBWREFTK_READERS", "g");
readers_src = readers_src.replace(exp,escape(ref));

var keywords = KWParser.parse();
var exp2 = new RegExp("BBWCCNTK_READERS", "g");
var utmccn = "(direct)%7Cutmcsr%3D(direct)%7Cutmcmd%3D(none)";

var domain = document.domain;
var path = document.URL.replace("https://","");
path = path.replace("http://","");
path = path.replace(domain,"");


if (keywords == null)
{
	if (ref == "-") { } else
	{ var utmccn = "(referral)%7Cutmcsr%3D" + domain + "%7Cutmcct%3D" + path + "%7Cutmcmd%3Dreferral"; }
}
else
{
	utmctr = keywords[1].join("%2B");
	var utmccn = "(organic)%7Cutmcsr%3D" + keywords[0] + "%7Cutmctr%3D" + utmctr + "%7Cutmcmd%3Dorganic";
}

readers_src = readers_src.replace(exp2,utmccn);

function drawBBreaders(s){ document.write(s); }

drawBBreaders(readers_src);
